
#include <stdio.h>

#define MAX  200

int px[MAX], py[MAX], pc;

int main (void)
{
    int x, y, i, j, c1, c2, max;
    double r;
    for ( ; ; )
    {
	scanf ("%d%d%lf", &x, &y, &r);
	if ( r < 0 )  break;
	scanf ("%d", &i);
	pc = 0;
	while ( i-- > 0 )
	{
	    scanf ("%d%d", px+pc, py+pc);
	    px[pc] -= x;
	    py[pc] -= y;
	    if ( px[pc]*px[pc] + py[pc]*py[pc] <= r*r + 1E-9 )  ++pc;
	}

        max = 0;
        for ( j = 0;  j < pc;  ++j )
        {
	    c1 = c2 = 0;
	    for ( i = 0;  i < pc;  ++i )
	    {
		if ( px[i] * py[j] >= px[j] * py[i] )  ++c1;
		if ( px[i] * py[j] <= px[j] * py[i] )  ++c2;
	    }
	    if ( c1 > max )  max = c1;
	    if ( c2 > max )  max = c2;
	}
	printf ("%d\n", max);
    }
    return 0;
}
